
#ifndef BLDC_H
#define BLDC_H

#include "config.h"

// 쓮i݊蓖
#define UL			PB0
#define UH			PB1
#define VL			PB2
#define VH			PB3
#define WL			PB4
#define WH			PB5

// ]쓮l
#define CS1_FWD		((1 << VL) | (1 << WH))
#define CS2_FWD		((1 << VL) | (1 << UH))
#define CS3_FWD		((1 << WL) | (1 << UH))
#define CS4_FWD		((1 << WL) | (1 << VH))
#define CS5_FWD		((1 << UL) | (1 << VH))
#define CS6_FWD		((1 << UL) | (1 << WH))

// t]쓮l
#define CS1_REV		((1 << WL) | (1 << VH))
#define CS2_REV		((1 << WL) | (1 << UH))
#define CS3_REV		((1 << VL) | (1 << UH))
#define CS4_REV		((1 << VL) | (1 << WH))
#define CS5_REV		((1 << UL) | (1 << WH))
#define CS6_REV		((1 << UL) | (1 << VH))

// ΰيmlŎwꂽ]쓮po͗l\
#ifdef __ICCAVR__
code U8
#elif __GNUC__
U8
#endif
commTableForward[8] = {
  0x00,			// ΰيml=0, sΰيmԁA쓮֎~
  CS6_FWD,		// ΰيml=1
  CS2_FWD,		// ΰيml=2
  CS1_FWD,		// ΰيml=3
  CS4_FWD,		// ΰيml=4
  CS5_FWD,		// ΰيml=5
  CS3_FWD,		// ΰيml=6
  0x00			// ΰيml=7, sΰيmԁA쓮֎~
};

// ΰيmlŎwꂽt]쓮po͗l\
#ifdef __ICCAVR__
code U8
#elif __GNUC__
U8
#endif
commTableReverse[8] = {
  0x00,			// ΰيml=0, sΰيmԁA쓮֎~
  CS2_REV,		// ΰيml=1
  CS6_REV,		// ΰيml=2
  CS1_REV,		// ΰيml=3
  CS4_REV,		// ΰيml=4
  CS3_REV,		// ΰيml=5
  CS5_REV,		// ΰيml=6
  0x00			// ΰيml=7, sΰيmԁA쓮֎~
};

#define PWM_TOP_VALUE		0x3FF			// PWMvpl

// PA7I邽߂A/Dϊ푽dݒ
#define ADMUX_PA7			((1 << MUX2) | (1 << MUX1))
#define ADMUX_PA1			((1 << MUX0))
#define ADMUX_PA2			((2 << MUX0))

#define ADC_PRESCALER		(1 << ADPS2)	// A/DϊOuݒ

// AsA/Dϊݒ肷邽߂̋NI
#define ADC_TS_FREERUNNING	((0 << ADTS2) | (0 << ADTS1) | (0 << ADTS0))

// őA/Dϊǂݎl
#define ADC_MAX				0x1EB			// ɊÂ
#define ADC_TWI				0x3FF			// TWIADCɐڑ

// ėpI/Oڼ޽0̱ڽ(׸ޕϐ̂߂̍Ɏgp)
#define GPIOR0_ADDR			0x2A

// x
// K_SPEED=(60*255)/(n*t_timer0*speed_max(rpm))
// n:ɂ̑ΐAt_timer0:16s
#define K_SPEED				34152			// ő呬x : 7000 (MC100d@)
//#define K_SPEED			11250			// ő呬x : 17000 (MMT 35-1LSd@)
// Αx̌vZ]ނȂA
// Αx=*葬x
// =60/(n*K_SPEED*t_timer0)

// ֐^錾
extern void Commutate(void);
extern void PLLInit(void);
extern void PWMInit(void);
extern void HallSensorInit(void);
extern void ADCInit(void);
extern void Timer0Init(void);
extern void PortsInit(void);
extern void MotorSetDutyCycle(U16 duty);
extern void SpeedMeasurement(void);

#endif
