//!
//! @file config_motor.h,v
//!
//! Copyright (c) 2007 Atmel.
//!
//! @brief Motor Configuration
//!
//! @version 1.16
//!

//_____ ݸٰ _______________________________________________________________

#ifndef _CONFIG_MOTOR_H_
#define _CONFIG_MOTOR_H_

/**
 * @brief ̗񋓂ΰيmɊւ6̈قȂl܂݂܂B
 * ݌vB\n ̉pł͂܂3ΰيm킪gp܂B
 * ΰيm:ʒu1`6
 */
enum {HS_001=1,HS_010=2,HS_011=3,HS_100=4,HS_101=5,HS_110=6};

/**
 * @brief  d@2̏Ԃ`
 */
  enum {RUN = TRUE, STOP = FALSE};

/**
 * @brief d@̕` : CCW(v)CW(v)
 */
  enum {CCW = TRUE, CW = FALSE};

// ٽϒ̌``
//#define HIGH_AND_LOW_PWM	// AT90PWM3B̒`Ԃœ܂B
// AT90PWM3B: HighLowPWM(`)ɂẮA1,2,4XΓ`Ԃgp
//			  ADC𒲐ĂB

// x`ƍ̎搔`
//#define AVERAGE_SPEED_MEASURE
#define n_SAMPLE				8

// d@pϸے`
#define OPEN_LOOP				0
#define SPEED_LOOP				1
#define CURRENT_LOOP			2

// ɂȂ̐W`Ȃ΂Ȃ܂B
// WpKp
// ϕWpKi
// WpKd

// xW
#define Kp_speed				8	//  1:MMTd@A8:MAXONd@
#define Ki_speed				8	// 10:MMTd@A8:MAXONd@
#define Kd_speed				0

// dW
#define Kp_cur					1
#define Ki_cur					3
#define Kd_cur					0

// ʒuW
#define Kp_pos					9	// 8
#define Ki_pos					3	// 1
#define Kd_pos					20	// 5

// SĂPIDW2K{܂B
// Ⴆ : kp=1  Kp=1*2^K_scal=1*2^4=16
// ʂ𓾂邽߂ɐl2^K_scalŏZȂ΂Ȃ܂B
// ̂K_scal̉EړsĂB
#define K_speed_scal			4	// 4:MMTd@A5:MAXONd@
#define K_cur_scal				4
#define K_pos_scal				5

// x
// K_SPEED=(60*255)/(n*t_timer0*speed_max(rpm))
// n:ɂ̑ΐAt_timer0:16s
#define K_SPEED					34152	// ő呬x : 7000 (MC100d@)
//#define K_SPEED				11250	// ő呬x : 17000 (MMT 35-1LSd@)
// Αx̌vZ]ނȂA
// Αx=*葬x
// =60/(n*K_SPEED*t_timer0)

#endif

/* D/AϊɊւIMAX͈ȉ̂悤ɌvZ܂B
   Rshunt=0.1
   Vref=2.56V
   D/Aϊ͍Âɂ8ޯD/Aϊ̂悤łB
   IMAX=imax(A)*256*0.1/2.56
   IMAX=imax*10
#define IMAX					(6 * 10)	/* 6A */
